Get a Cloud Instance's current state/information

GET /pcloud/v1/cloud-instances/{cloud_instance_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.cloud-instance.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-instance.read

Request

Response

200 - OK

capabilities

array

Cloud Instance Capabilities

cloudInstanceID

string

Cloud Instance ID

enabled

boolean

Indicates if the cloud instance is enabled

initialized

boolean

Indicates if the cloud instance is initialized and ready for use

limits

object

Limits on the cloud instance

name

string

Cloud Instance Name

openstackID

string

The open stack ID that controls this cloud instance

pvmInstances

array

PVM instances owned by the Cloud Instance

region

string

The region the cloud instance lives

tenantID

string

The tenant ID that owns this cloud instance

usage

object

Current usage on the cloud instance

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get all cloud connections in this cloud instance

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/cloud-connections

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.cloud-connection.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-connection.list

Request

Response

200 - OK

cloudConnections

array

Cloud Connections

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

408 - Request Timeout

description

string

error

string

500 - Internal Server Error

description

string

error

string

Create a new cloud connection

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/cloud-connections

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.cloud-connection.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-connection.create

Request

Request Body

CloudConnectionCreate

Parameters for the creation of a new cloud connection

classic

object

enabled

boolean

enable classic endpoint destination (default=false)

gre

object

globalRouting

boolean

enable global routing for this cloud connection (default=false)

metered

boolean

enable metered for this cloud connection (default=false)

name

Required *

string

name of the cloud connection

speed

Required *

integer

speed of the cloud connection (speed in megabits per second)

subnets

array

list of subnets to attach to cloud connection

transitEnabled

boolean

enable transit gateway for this cloud connection (default=false)

vpc

object

enabled

boolean

enable vpc for this cloud connection (default=false)

vpcs

array

vpc connections

Response

200 - OK

classic

object

cloudConnectionID

string

cloud connection ID

connectionMode

string

type of service the gateway is attached to

creationDate

string

creation date

globalRouting

boolean

enable global routing for this cloud connection (default=false)

ibmIPAddress

string

IBM IP address

linkStatus

string

link status

metered

boolean

metered

name

string

name of the cloud connection

networks

array

Network References

port

string

port

speed

integer

speed of the cloud connection (speed in megabits per second)

userIPAddress

string

user IP address

vpc

object

201 - Created

classic

object

cloudConnectionID

string

cloud connection ID

connectionMode

string

type of service the gateway is attached to

creationDate

string

creation date

globalRouting

boolean

enable global routing for this cloud connection (default=false)

ibmIPAddress

string

IBM IP address

linkStatus

string

link status

metered

boolean

metered

name

string

name of the cloud connection

networks

array

Network References

port

string

port

speed

integer

speed of the cloud connection (speed in megabits per second)

userIPAddress

string

user IP address

vpc

object

202 - Accepted

classic

object

cloudConnectionID

string

cloud connection ID

connectionMode

string

type of service the gateway is attached to

creationDate

string

creation date

globalRouting

boolean

enable global routing for this cloud connection (default=false)

ibmIPAddress

string

IBM IP address

linkStatus

string

link status

metered

boolean

metered

name

string

name of the cloud connection

networks

array

Network References

port

string

port

speed

integer

speed of the cloud connection (speed in megabits per second)

userIPAddress

string

user IP address

vpc

object

jobRef

JobReference

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

405 - Method Not Allowed

description

string

error

string

408 - Request Timeout

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

503 - Service Unavailable

description

string

error

string

504 - Gateway Timeout

description

string

error

string

Get all virtual private cloud connections in this cloud instance

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/cloud-connections-virtual-private-clouds

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.cloud-connection-vpc.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-connection.list

Request

Response

200 - OK

virtualPrivateClouds

array

list of available virtual private clouds

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

408 - Request Timeout

description

string

error

string

500 - Internal Server Error

description

string

error

string

503 - Service Unavailable

description

string

error

string

504 - Gateway Timeout

description

string

error

string

Delete a Cloud Connection

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/cloud-connections/{cloud_connection_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.cloud-connection.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-connection.delete

Request

Response

200 - OK

202 - Accepted

href

string

Link to job resource

id

string

id of a job used to get status of long running operation

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

408 - Request Timeout

description

string

error

string

410 - Gone

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get a cloud connection's state/information

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/cloud-connections/{cloud_connection_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.cloud-connection.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-connection.read

Request

Response

200 - OK

classic

object

cloudConnectionID

string

cloud connection ID

connectionMode

string

type of service the gateway is attached to

creationDate

string

creation date

globalRouting

boolean

enable global routing for this cloud connection (default=false)

ibmIPAddress

string

IBM IP address

linkStatus

string

link status

metered

boolean

metered

name

string

name of the cloud connection

networks

array

Network References

port

string

port

speed

integer

speed of the cloud connection (speed in megabits per second)

userIPAddress

string

user IP address

vpc

object

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

408 - Request Timeout

description

string

error

string

500 - Internal Server Error

description

string

error

string

Update a Cloud Connection

PUT /pcloud/v1/cloud-instances/{cloud_instance_id}/cloud-connections/{cloud_connection_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.cloud-connection.update

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-connection.update

Request

Request Body

CloudConnectionUpdate

Parameters to update a Cloud Connection

classic

object

enabled

boolean

enable classic endpoint destination (default=false)

gre

object

globalRouting

boolean

enable global routing for this cloud connection (default=false)

metered

boolean

enable metered for this cloud connection (default=false)

name

string

name of the cloud connection

speed

integer

speed of the cloud connection (speed in megabits per second)

vpc

object

enabled

boolean

enable vpc for this cloud connection (default=false)

vpcs

array

vpc connections

Response

200 - OK

classic

object

cloudConnectionID

string

cloud connection ID

connectionMode

string

type of service the gateway is attached to

creationDate

string

creation date

globalRouting

boolean

enable global routing for this cloud connection (default=false)

ibmIPAddress

string

IBM IP address

linkStatus

string

link status

metered

boolean

metered

name

string

name of the cloud connection

networks

array

Network References

port

string

port

speed

integer

speed of the cloud connection (speed in megabits per second)

userIPAddress

string

user IP address

vpc

object

202 - Accepted

href

string

Link to job resource

id

string

id of a job used to get status of long running operation

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

405 - Method Not Allowed

description

string

error

string

408 - Request Timeout

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

503 - Service Unavailable

description

string

error

string

Detach a network from a Cloud Connection

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/cloud-connections/{cloud_connection_id}/networks/{network_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.cloud-connection-network.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-connection.delete

Request

Response

200 - OK

202 - Accepted

href

string

Link to job resource

id

string

id of a job used to get status of long running operation

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

408 - Request Timeout

description

string

error

string

410 - Gone

description

string

error

string

500 - Internal Server Error

description

string

error

string

Attach a network to the cloud connection

PUT /pcloud/v1/cloud-instances/{cloud_instance_id}/cloud-connections/{cloud_connection_id}/networks/{network_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.cloud-connection-network.update

Auditing

Calling this method generates the following auditing event.

  • power-iaas.cloud-connection.update

Request

Response

200 - OK

202 - Accepted

href

string

Link to job resource

id

string

id of a job used to get status of long running operation

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

408 - Request Timeout

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get detail of last cos-image import job

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/cos-images

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.cos-image.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.image.read

Request

Response

200 - OK

createTimestamp

string

create timestamp for the job

id

string

id of a job

operation

object

resources

object

resources involved in this job

status

object

workflow

JobWorkflow

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Create an cos-image import job

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/cos-images

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.cos-image.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.image.import

Request

Request Body

CreateCosImageImportJob

Parameters for the creation of a new cos-image import job

accessKey

string

Cloud Object Storage access key; required for buckets with private access

bucketAccess

string

indicates if the bucket has public or private access public access require no authentication keys private access requires hmac authentication keys (access,secret)

bucketName

Required *

string

Cloud Object Storage bucket name; bucket-name[/optional/folder]

imageFilename

Required *

string

Cloud Object Storage image filename

imageName

Required *

string

Name for the image that will be loaded into the boot image catalog

importDetails

object

Import details for SAP images

licenseType

Required *

string

Origin of the license of the product

product

Required *

string

Product within the image

vendor

Required *

string

Vendor supporting the product

osType

string

Image OS Type, required if importing a raw image; raw images can only be imported using the command line interface

region

string

Cloud Object Storage region

secretKey

string

Cloud Object Storage secret key; required for buckets with private access

storageAffinity

object

Storage affinity data used for storage pool selection

affinityPVMInstance

string

PVM Instance (ID or Name) to base storage affinity policy against; required if requesting storage affinity and affinityVolume is not provided

affinityPolicy

string

Affinity policy for storage pool selection; ignored if storagePool provided; for policy 'affinity' requires one of affinityPVMInstance or affinityVolume to be specified; for policy 'anti-affinity' requires one of antiAffinityPVMInstances or antiAffinityVolumes to be specified

affinityVolume

string

Volume (ID or Name) to base storage affinity policy against; required if requesting storage affinity and affinityPVMInstance is not provided

antiAffinityPVMInstances

array

List of pvmInstances to base storage anti-affinity policy against; required if requesting storage anti-affinity and antiAffinityVolumes is not provided

antiAffinityVolumes

array

List of volumes to base storage anti-affinity policy against; required if requesting storage anti-affinity and antiAffinityPVMInstances is not provided

storagePool

string

Storage pool where the image will be loaded, if provided then storageAffinity will be ignored

storageType

string

Type of storage; If only using storageType for storage selection then the storage pool with the most available space will be selected if storageType is not provided the storage type will default to 'tier3'.

userTags

object

List of user tags

Response

202 - Accepted, cos-image import successfully added to the jobs queue

href

string

Link to job resource

id

string

id of a job used to get status of long running operation

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get events from this cloud instance since a specific timestamp

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/events

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.event.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.event.list

Request

Path Parameters

Query Parameters

time

string

(deprecated - use from_time) A time in either ISO 8601 or unix epoch format

from_time

string

A from query time in either ISO 8601 or unix epoch format

to_time

string

A to query time in either ISO 8601 or unix epoch format

Response

200 - OK

events

array

Events

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get a single event

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/events/{event_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.event.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.event.read

Request

Path Parameters

Query Parameters

Response

200 - OK

action

string

Type of action for this event

eventID

string

ID of the Activity

level

string

Level of the event (notice, info, warning, error)

message

string

The (translated) message of the event

metadata

object

Any metadata associated with the event

resource

string

Type of resource for this event

time

string

Time of activity in ISO 8601 - RFC3339

timestamp

integer

Time of activity in unix epoch

user

EventUser

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

List all images for this cloud instance

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/images

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.cloud-instance-image.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.image.list

Request

Response

200 - OK

images

array

Images

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Create a new Image (from available images)

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/images

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.cloud-instance-image.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.image.import

Request

Request Body

CreateImage

Parameters for the creation of a new image from available images

accessKey

string

Cloud Storage access key; required for import image

bucketName

string

Cloud Storage bucket name; bucket-name[/optional/folder]; required for import image

diskType

string

Type of Disk; if diskType is not provided the disk type will default to 'tier3'. Used only when importing an image from cloud storage.

imageFilename

string

Cloud Storage image filename; required for import image

imageID

string

Image ID of existing source image; required for copy image

imageName

string

Name to give created image; required for import image

imagePath

string

(deprecated - replaced by region, imageFilename and bucketName) Path to image starting with service endpoint and ending with image filename

osType

string

Image OS Type, required if importing a raw image; raw images can only be imported using the command line interface

region

string

Cloud Storage Region; only required to access IBM Cloud Storage

secretKey

string

Cloud Storage secret key; required for import image

source

Required *

string

Source of the image > Note: url option is deprecated, this option is supported till Oct 2022

storageAffinity

object

The storage affinity data; ignored if storagePool is provided; Used only when importing an image from cloud storage.

affinityPVMInstance

string

PVM Instance (ID or Name) to base storage affinity policy against; required if requesting storage affinity and affinityVolume is not provided

affinityPolicy

string

Affinity policy for storage pool selection; ignored if storagePool provided; for policy 'affinity' requires one of affinityPVMInstance or affinityVolume to be specified; for policy 'anti-affinity' requires one of antiAffinityPVMInstances or antiAffinityVolumes to be specified

affinityVolume

string

Volume (ID or Name) to base storage affinity policy against; required if requesting storage affinity and affinityPVMInstance is not provided

antiAffinityPVMInstances

array

List of pvmInstances to base storage anti-affinity policy against; required if requesting storage anti-affinity and antiAffinityVolumes is not provided

antiAffinityVolumes

array

List of volumes to base storage anti-affinity policy against; required if requesting storage anti-affinity and antiAffinityPVMInstances is not provided

storagePool

string

Storage pool where the image will be loaded; if provided then storageAffinity will be ignored; Used only when importing an image from cloud storage.

userTags

object

List of user tags

Response

200 - OK

creationDate

string

Creation Date

crn

object

The CRN for this resource

description

string

Description

imageID

string

Image ID

lastUpdateDate

string

Last Update Date

maxImageVolumeSize

number

Maximum image volume size for multi-volume image

name

string

Image Name

servers

array

List of Servers that have deployed the image

size

number

Image Size

specifications

object

state

string

Image State

storagePool

string

Storage pool where the image resides

storageType

string

Storage type for image

taskref

object

userTags

object

List of user tags

volumes

array

Image Volumes

201 - Created

creationDate

string

Creation Date

crn

object

The CRN for this resource

description

string

Description

imageID

string

Image ID

lastUpdateDate

string

Last Update Date

maxImageVolumeSize

number

Maximum image volume size for multi-volume image

name

string

Image Name

servers

array

List of Servers that have deployed the image

size

number

Image Size

specifications

object

state

string

Image State

storagePool

string

Storage pool where the image resides

storageType

string

Storage type for image

taskref

object

userTags

object

List of user tags

volumes

array

Image Volumes

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Delete an Image from a Cloud Instance

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/images/{image_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.cloud-instance-image.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.image.delete

Request

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

410 - Gone

description

string

error

string

500 - Internal Server Error

description

string

error

string

Detailed info of an image

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/images/{image_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.cloud-instance-image.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.image.read

Request

Response

200 - OK

creationDate

string

Creation Date

crn

object

The CRN for this resource

description

string

Description

imageID

string

Image ID

lastUpdateDate

string

Last Update Date

maxImageVolumeSize

number

Maximum image volume size for multi-volume image

name

string

Image Name

servers

array

List of Servers that have deployed the image

size

number

Image Size

specifications

object

state

string

Image State

storagePool

string

Storage pool where the image resides

storageType

string

Storage type for image

taskref

object

userTags

object

List of user tags

volumes

array

Image Volumes

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Export an image

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/images/{image_id}/export

This API is deprecated for /pcloud/v2/cloud-instances/{cloud_instance_id}/images/{image_id}/export.

>Note: Support for this API is available till Oct 2022.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.image-export.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.image.export

Request

Request Body

ExportImage

Parameters for exporting an image

accessKey

Required *

string

Cloud Object Storage Access key

bucketName

Required *

string

Cloud Object Storage Bucket name

region

string

Cloud Object Storage Region; required for IBM COS

secretKey

string

Cloud Object Storage Secret key

Response

202 - Accepted

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

List up to the last 5 jobs initiated by the cloud instance

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/jobs

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.job.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.job.list

Request

Path Parameters

Query Parameters

operation.id

string

Operation ID to filter jobs (optional)

operation.target

string

Operation target to filter jobs (optional)

operation.action

string

Operation action to filter jobs (optional) vmCapture - includes operation action value (vmCapture) imageExport - includes operation action value (imageExport) imageImport - includes operation action value (imageImport) storage - includes operation action values (vmCapture,imageExport,imageImport)

Response

200 - OK

jobs

array

Jobs

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Delete a cloud instance job

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/jobs/{job_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.job.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.job.delete

Request

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

500 - Internal Server Error

description

string

error

string

List the detail of a job

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/jobs/{job_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.job.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.job.read

Request

Response

200 - OK

createTimestamp

string

create timestamp for the job

id

string

id of a job

operation

object

resources

object

resources involved in this job

status

object

workflow

JobWorkflow

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get the disaster recovery site details for the current location

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/locations/disaster-recovery

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.disaster-recovery.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.disaster-recovery.read

Request

Response

200 - OK

location

string

regionZone of a site

replicationSites

object

list of Replication Sites

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get all networks in this cloud instance

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/networks

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.network.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.network.list

Request

Path Parameters

Query Parameters

filter

string

A filter expression that filters resources listed in the response

Response

200 - OK

networks

array

Network References

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Create a new Network

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.network.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.network.create

Request

Request Body

NetworkCreate

Parameters for the creation of a new network

accessConfig

string

[DEPRECATED] Network communication configuration (for satellite locations only) * `internal-only` - network is only used for internal host communication * `outbound-only` - network will be capable of egress traffic * `bidirectional-static-route` - network will be capable of ingress and egress traffic via static routes * `bidirectional-bgp` - network will be capable of ingress and egress traffic via bgp configuration * `bidirectional-l2out` - network will be capable of ingress and egress traffic via l2out ACI configuration

string

Indicates if the network is advertised externally of the workspace to PER and\or peer networks

arpBroadcast

string

Indicates if ARP broadcast is enabled

cidr

string

Network in CIDR notation (192.168.0.0/24)

dnsServers

array

DNS Servers. If not specified, default is 127.0.0.1 for 'vlan' (private network) and 9.9.9.9 for 'pub-vlan' (public network)

gateway

string

Gateway IP Address

ipAddressRanges

array

IP Address Ranges

jumbo

boolean

(deprecated - replaced by mtu) Enable MTU Jumbo Network (for multi-zone locations only)

mtu

integer

Maximum transmission unit

name

string

Network Name

type

Required *

string

Type of Network - 'vlan' (private network), 'pub-vlan' (public network)

userTags

object

List of user tags

Response

200 - OK

accessConfig

string

[DEPRECATED] Network communication configuration (for satellite locations only) * `internal-only` - network is only used for internal host communication * `outbound-only` - network will be capable of egress traffic * `bidirectional-static-route` - network will be capable of ingress and egress traffic via static routes * `bidirectional-bgp` - network will be capable of ingress and egress traffic via bgp configuration * `bidirectional-l2out` - network will be capable of ingress and egress traffic via l2out ACI configuration

string

Indicates if the network is advertised externally of the workspace to PER and\or peer networks.

arpBroadcast

string

Indicates if the ARP broadcast is enabled

cidr

string

Network in CIDR notation (192.168.0.0/24)

cloudConnections

array

(currently not available) cloud connections this network is attached

crn

object

The CRN for this resource

dhcpManaged

boolean

DHCP Enabled Network

dnsServers

array

DNS Servers

gateway

string

Gateway IP Address

ipAddressMetrics

object

IP Address Metrics

ipAddressRanges

array

IP Address Ranges

jumbo

boolean

(deprecated - replaced by mtu) Enable MTU Jumbo Network (for multi-zone locations only)

mtu

integer

Maximum transmission unit

name

string

Network Name

networkID

string

Unique Network ID

publicIPAddressRanges

array

Public IP Address Ranges (for pub-vlan networks)

type

string

Type of Network - 'vlan' (private network) 'pub-vlan' (public network) 'dhcp-vlan' (for satellite locations only)

userTags

object

List of user tags

vlanID

number

VLAN ID

201 - Created

accessConfig

string

[DEPRECATED] Network communication configuration (for satellite locations only) * `internal-only` - network is only used for internal host communication * `outbound-only` - network will be capable of egress traffic * `bidirectional-static-route` - network will be capable of ingress and egress traffic via static routes * `bidirectional-bgp` - network will be capable of ingress and egress traffic via bgp configuration * `bidirectional-l2out` - network will be capable of ingress and egress traffic via l2out ACI configuration

string

Indicates if the network is advertised externally of the workspace to PER and\or peer networks.

arpBroadcast

string

Indicates if the ARP broadcast is enabled

cidr

string

Network in CIDR notation (192.168.0.0/24)

cloudConnections

array

(currently not available) cloud connections this network is attached

crn

object

The CRN for this resource

dhcpManaged

boolean

DHCP Enabled Network

dnsServers

array

DNS Servers

gateway

string

Gateway IP Address

ipAddressMetrics

object

IP Address Metrics

ipAddressRanges

array

IP Address Ranges

jumbo

boolean

(deprecated - replaced by mtu) Enable MTU Jumbo Network (for multi-zone locations only)

mtu

integer

Maximum transmission unit

name

string

Network Name

networkID

string

Unique Network ID

publicIPAddressRanges

array

Public IP Address Ranges (for pub-vlan networks)

type

string

Type of Network - 'vlan' (private network) 'pub-vlan' (public network) 'dhcp-vlan' (for satellite locations only)

userTags

object

List of user tags

vlanID

number

VLAN ID

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

550 - Workspace Status Error

description

string

error

string

Delete a Network

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/networks/{network_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.network.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.network.delete

Request

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

410 - Gone

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get a network's current state/information

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/networks/{network_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.network.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.network.read

Request

Response

200 - OK

accessConfig

string

[DEPRECATED] Network communication configuration (for satellite locations only) * `internal-only` - network is only used for internal host communication * `outbound-only` - network will be capable of egress traffic * `bidirectional-static-route` - network will be capable of ingress and egress traffic via static routes * `bidirectional-bgp` - network will be capable of ingress and egress traffic via bgp configuration * `bidirectional-l2out` - network will be capable of ingress and egress traffic via l2out ACI configuration

string

Indicates if the network is advertised externally of the workspace to PER and\or peer networks.

arpBroadcast

string

Indicates if the ARP broadcast is enabled

cidr

string

Network in CIDR notation (192.168.0.0/24)

cloudConnections

array

(currently not available) cloud connections this network is attached

crn

object

The CRN for this resource

dhcpManaged

boolean

DHCP Enabled Network

dnsServers

array

DNS Servers

gateway

string

Gateway IP Address

ipAddressMetrics

object

IP Address Metrics

ipAddressRanges

array

IP Address Ranges

jumbo

boolean

(deprecated - replaced by mtu) Enable MTU Jumbo Network (for multi-zone locations only)

mtu

integer

Maximum transmission unit

name

string

Network Name

networkID

string

Unique Network ID

publicIPAddressRanges

array

Public IP Address Ranges (for pub-vlan networks)

type

string

Type of Network - 'vlan' (private network) 'pub-vlan' (public network) 'dhcp-vlan' (for satellite locations only)

userTags

object

List of user tags

vlanID

number

VLAN ID

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Update a Network

PUT /pcloud/v1/cloud-instances/{cloud_instance_id}/networks/{network_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.network.update

Auditing

Calling this method generates the following auditing event.

  • power-iaas.network.update

Request

Request Body

NetworkUpdate

Parameters to update a Network

string

Indicates if the network is advertised externally of the workspace to PER and\or peer networks

arpBroadcast

string

Indicates if the ARP broadcast is enabled

dnsServers

array

Replaces the current DNS Servers

gateway

string

Replaces the current Gateway IP Address

ipAddressRanges

array

Replaces the current IP Address Ranges

name

string

Replaces the current Network Name

Response

200 - OK

accessConfig

string

[DEPRECATED] Network communication configuration (for satellite locations only) * `internal-only` - network is only used for internal host communication * `outbound-only` - network will be capable of egress traffic * `bidirectional-static-route` - network will be capable of ingress and egress traffic via static routes * `bidirectional-bgp` - network will be capable of ingress and egress traffic via bgp configuration * `bidirectional-l2out` - network will be capable of ingress and egress traffic via l2out ACI configuration

string

Indicates if the network is advertised externally of the workspace to PER and\or peer networks.

arpBroadcast

string

Indicates if the ARP broadcast is enabled

cidr

string

Network in CIDR notation (192.168.0.0/24)

cloudConnections

array

(currently not available) cloud connections this network is attached

crn

object

The CRN for this resource

dhcpManaged

boolean

DHCP Enabled Network

dnsServers

array

DNS Servers

gateway

string

Gateway IP Address

ipAddressMetrics

object

IP Address Metrics

ipAddressRanges

array

IP Address Ranges

jumbo

boolean

(deprecated - replaced by mtu) Enable MTU Jumbo Network (for multi-zone locations only)

mtu

integer

Maximum transmission unit

name

string

Network Name

networkID

string

Unique Network ID

publicIPAddressRanges

array

Public IP Address Ranges (for pub-vlan networks)

type

string

Type of Network - 'vlan' (private network) 'pub-vlan' (public network) 'dhcp-vlan' (for satellite locations only)

userTags

object

List of user tags

vlanID

number

VLAN ID

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get all ports for this network

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/networks/{network_id}/ports

This API is deprecated for /v1/networks/{network_id}/network-interfaces.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.network-port.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.port.list

Request

Response

200 - OK

ports

array

Network Ports

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Perform port addition, deletion, and listing

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/networks/{network_id}/ports

This API is deprecated for /v1/networks/{network_id}/network-interfaces.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.network-port.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.port.create

Request

Request Body

NetworkPortCreate

Create a Network Port

description

string

Description of the port (not unique or indexable)

ipAddress

string

The requested ip address of this port

Response

201 - Created

description

string

Description of the port (not unique or indexable)

externalIP

string

The external ip address (for pub-vlan networks)

href

string

Link to port resource

ipAddress

string

The ip address of this port

macAddress

string

The mac address of the network interface

portID

string

The unique Port ID

pvmInstance

object

The attached pvm-instance to this port

status

string

Te

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Delete a Network Port

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/networks/{network_id}/ports/{port_id}

This API is deprecated for /v1/networks/{network_id}/network-interfaces/{network_interface_id}.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.network-port.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.port.delete

Request

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

410 - Gone

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get a port's information

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/networks/{network_id}/ports/{port_id}

This API is deprecated for /v1/networks/{network_id}/network-interfaces/{network_interface_id}.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.network-port.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.port.read

Request

Response

200 - OK

description

string

Description of the port (not unique or indexable)

externalIP

string

The external ip address (for pub-vlan networks)

href

string

Link to port resource

ipAddress

string

The ip address of this port

macAddress

string

The mac address of the network interface

portID

string

The unique Port ID

pvmInstance

object

The attached pvm-instance to this port

status

string

Te

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Update a port's information

PUT /pcloud/v1/cloud-instances/{cloud_instance_id}/networks/{network_id}/ports/{port_id}

This API is deprecated for /v1/networks/{network_id}/network-interfaces/{network_interface_id}.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.network-port.update

Auditing

Calling this method generates the following auditing event.

  • power-iaas.port.update

Request

Request Body

NetworkPortUpdate

Parameters for updating a Port

description

string

Description of the port (not unique or indexable)

pvmInstanceID

string

If supplied populated it attaches to the PVMInstanceID, if empty detaches from PVMInstanceID

Response

200 - OK

description

string

Description of the port (not unique or indexable)

externalIP

string

The external ip address (for pub-vlan networks)

href

string

Link to port resource

ipAddress

string

The ip address of this port

macAddress

string

The mac address of the network interface

portID

string

The unique Port ID

pvmInstance

object

The attached pvm-instance to this port

status

string

Te

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get all Server Placement Groups

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/placement-groups

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.placement-group.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.placement-group.list

Request

Response

200 - OK

placementGroups

array

List of Server Placement Groups

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Create a new Server Placement Group

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/placement-groups

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.placement-group.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.placement-group.create

Request

Request Body

PlacementGroupCreate

Parameters for the creation of a new Server Placement Group

name

Required *

string

The name of the Placement Group

policy

Required *

string

The Placement Group Policy

userTags

object

List of user tags

Response

200 - OK

crn

object

The CRN for this resource

id

string

The id of the Placement Group

members

array

The List of PVM Instance IDs associated with the Placement Group

name

string

The name of the Placement Group

policy

string

The Placement Group Policy

userTags

object

List of user tags

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Delete Server Placement Group

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/placement-groups/{placement_group_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.placement-group.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.placement-group.delete

Request

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get Server Placement Group detail

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/placement-groups/{placement_group_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.placement-group.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.placement-group.read

Request

Response

200 - OK

crn

object

The CRN for this resource

id

string

The id of the Placement Group

members

array

The List of PVM Instance IDs associated with the Placement Group

name

string

The name of the Placement Group

policy

string

The Placement Group Policy

userTags

object

List of user tags

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Remove Server from Placement Group

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/placement-groups/{placement_group_id}/members

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.placement-group-member.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.placement-groups.update

Request

Request Body

PlacementGroupServer

Parameters for removing a Server in a Placement Group

id

Required *

string

The ID of the Server

Response

200 - OK

crn

object

The CRN for this resource

id

string

The id of the Placement Group

members

array

The List of PVM Instance IDs associated with the Placement Group

name

string

The name of the Placement Group

policy

string

The Placement Group Policy

userTags

object

List of user tags

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Add Server to Placement Group

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/placement-groups/{placement_group_id}/members

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.placement-group-member.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.placement-groups.update

Request

Request Body

PlacementGroupServer

Parameters for adding a server to a Server Placement Group

id

Required *

string

The ID of the Server

Response

200 - OK

crn

object

The CRN for this resource

id

string

The id of the Placement Group

members

array

The List of PVM Instance IDs associated with the Placement Group

name

string

The name of the Placement Group

policy

string

The Placement Group Policy

userTags

object

List of user tags

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

List of available resources within a particular Pod

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/pod-capacity

Applicable to satellite locations only.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.pod-capacity.view

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pod-capacity.list

Request

Response

200 - OK

PodData

PodData

Description of a PPCaaS Pod

StorageControllers

StorageControllers

List of available storage controllers within a particular DataCenter

SystemPools

SystemPoolsCapacity

List of available system pools within a Pod

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get all the pvm instances for this cloud instance

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.list

Request

Response

200 - OK

pvmInstances

array

PVM Instance References

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

408 - Request Timeout

description

string

error

string

500 - Internal Server Error

description

string

error

string

Create a new Power VM Instance

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.create

Request

Request Body

PVMInstanceCreate

Parameters for the creation of a new Power VM Instance

allowRemoteRestart

boolean

if set to false, automated remote restart is disabled for the VM

defaultTrustedProfile

object

default IAM trusted profile to use for this virtual server instance

boolean

If set to true, the system will create a link to the specified trusted profile during server creation. Regardless of whether a link is created by the system or manually using the IAM Identity service, it will be automatically deleted when the server is deleted.

target

Required *

object

trusted profile associated with the VM. Specify one of crn, id or name

deploymentTarget

object

The deployment of a dedicated host

id

Required *

string

The uuid of the host group or host

type

Required *

string

specify if deploying to a host group or a host

deploymentType

string

The custom deployment type

imageID

Required *

string

Image ID of the image to use for the server

keyPairName

string

The name of the SSH key pair provided to the server for authenticating users (looked up in the tenant's list of keys)

licenseRepositoryCapacity

integer

The VTL license repository capacity TiB value

memory

Required *

number

Amount of memory allocated (in GiB)

metadataService

object

The metadata service configuration

enabled

Required *

boolean

Indicates whether the metadata service endpoint will be available to the virtual server

migratable

boolean

(deprecated - replaced by pinPolicy) Indicates if the server is allowed to migrate between hosts

networkIDs

array

(deprecated - replaced by networks) List of Network IDs

networks

array

The pvm instance networks information

pinPolicy

string

Specify PVM pin policy

placementGroup

string

The placement group for the server

preferredProcessorCompatibilityMode

string

processor compatibility mode

procType

Required *

string

Processor type (dedicated, shared, capped)

processors

Required *

number

Number of processors allocated

replicantAffinityPolicy

string

Affinity policy for replicants being created; affinity for the same host, anti-affinity for different hosts, none for no preference

replicantNamingScheme

string

How to name the created vms

replicants

number

Number of duplicate instances to create in this request

serverName

Required *

string

Name of the server to create

sharedProcessorPool

string

The shared processor pool for server deployment

softwareLicenses

object

The pvm instance Software Licenses

ibmiCSS

boolean

IBMi Cloud Storage Solution

ibmiDBQ

boolean

IBMi Cloud Storage Solution

ibmiPHA

boolean

IBMi Power High Availability IASP Management Software License

ibmiPHAFSM

boolean

IBMi Power High Availability Full System Manager (FSM) Software License

ibmiPHAFSMCount

integer

Number of IBMi Power High Availability Full System Manager (FSM) Managed Servers

ibmiRDS

boolean

IBMi Rational Dev Studio

ibmiRDSUsers

integer

IBMi Rational Dev Studio Number of User Licenses

storageAffinity

object

The storage affinity data; ignored if storagePool is provided; Only valid when you deploy one of the IBM supplied stock images. Storage pool for a custom image (an imported image or an image that is created from a PVMInstance capture) defaults to the storage pool the image was created in

affinityPVMInstance

string

PVM Instance (ID or Name) to base storage affinity policy against; required if requesting storage affinity and affinityVolume is not provided

affinityPolicy

string

Affinity policy for storage pool selection; ignored if storagePool provided; for policy 'affinity' requires one of affinityPVMInstance or affinityVolume to be specified; for policy 'anti-affinity' requires one of antiAffinityPVMInstances or antiAffinityVolumes to be specified

affinityVolume

string

Volume (ID or Name) to base storage affinity policy against; required if requesting storage affinity and affinityPVMInstance is not provided

antiAffinityPVMInstances

array

List of pvmInstances to base storage anti-affinity policy against; required if requesting storage anti-affinity and antiAffinityVolumes is not provided

antiAffinityVolumes

array

List of volumes to base storage anti-affinity policy against; required if requesting storage anti-affinity and antiAffinityPVMInstances is not provided

storageConnection

string

The storage connection type

storagePool

string

Storage Pool for server deployment; if provided then storageAffinity will be ignored; Only valid when you deploy one of the IBM supplied stock images. Storage pool for a custom image (an imported image or an image that is created from a PVMInstance capture) defaults to the storage pool the image was created in

storagePoolAffinity

boolean

Indicates if all volumes attached to the PVMInstance must reside in the same storage pool. If set to false, volumes from any storage pool can be attached to the PVMInstance. This flag only impacts PVMInstance snapshot and capture operations. For capture, only volumes that reside in the same storage pool as the PVMInstance's boot volume can be included. For snapshots, all volumes included in the snapshot must reside in the same storage pool.

storageType

string

Storage type for server deployment; if storageType is not provided the storage type will default to 'tier3'.

sysType

string

System type used to host the instance; use GET /v1/datacenters to retrieve supported system types for a location.

userData

string

Cloud init user defined data; For FLS, only cloud-config user-data is supported and data must not be compressed or exceed 63K

userTags

object

List of user tags

virtualCores

object

The pvm instance virtual CPU information

assigned

Required *

integer

The active virtual Cores

max

integer

The maximum DLPAR range for virtual Cores (Display only support)

min

integer

The minimum DLPAR range for virtual Cores (Display only support)

virtualSerialNumber

object

Virtual Serial Number information

description

string

Description of the Virtual Serial Number

serial

Required *

string

Provide an existing reserved Virtual Serial Number or specify 'auto-assign' for auto generated Virtual Serial Number.

softwareTier

object

IBMi licensing software tier for the VSI.

volumeIDs

array

List of volume IDs

vpmemVolumes

array

The vPMEM volumes information

Path Parameters

Query Parameters

skipHostValidation

boolean

Option to skip host validation on PVMInstance Create API

Response

200 - OK

201 - Created

202 - Accepted

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

504 - Gateway Timeout. Request is still processing and taking longer than expected.

description

string

error

string

Delete a PCloud PVM Instance

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.delete

Request

Request Body

PVMInstanceDelete

Parameters to delete a PVM Instance

retainVSN

boolean

Indicates if the Virtual Serial Number attached to a PVM Instance is retained or not

Path Parameters

Query Parameters

delete_data_volumes

boolean

Indicates if all data volumes attached to the PVMInstance should be deleted when deleting the PVMInstance. Shared data volumes will be deleted if there are no other PVMInstances attached.

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

410 - Gone

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get a PVM Instance's current state or information

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.read

Request

Response

200 - OK

addresses

array

(deprecated - replaced by networks) The list of addresses and their network information

allowRemoteRestart

boolean

if set to false, automated remote restart is disabled for the VM

consoleLanguage

object

Console language and code

creationDate

string

Date/Time of PVM creation

crn

object

The CRN for this resource

dedicatedHostID

string

ID of the dedicated host where the PVM Instance is running, if applicable

defaultTrustedProfile

object

default IAM trusted profile to use for this virtual server instance

deploymentType

string

The custom deployment type

diskSize

number

Size of allocated disk (in GiB)

effectiveProcessorCompatibilityMode

string

Effective processor compatibility mode

fault

PVMInstanceFault

Fault information (if occurred)

health

PVMInstanceHealth

PVM's health status details

hostID

integer

The PVM Instance Host ID (Internal Use Only)

imageID

string

The ImageID used by the server

licenseRepositoryCapacity

integer

The VTL license repository capacity TiB value

maxmem

number

Maximum amount of memory that can be allocated (in GiB, for resize)

maxproc

number

Maximum number of processors that can be allocated (for resize)

memory

number

Amount of memory allocated (in GiB)

metadataService

object

The metadata service configuration

migratable

boolean

whether the instance can be migrated

minmem

number

Minimum amount of memory that can be allocated (in GiB, for resize)

minproc

number

Minimum number of processors that can be allocated (for resize)

networkIDs

array

(deprecated - replaced by networks) List of Network IDs

networks

array

The pvm instance networks information

operatingSystem

string

OS system information (usually version and build)

osType

string

Type of the OS [aix, ibmi, rhel, sles, vtl, rhcos]

pinPolicy

string

VM pinning policy to use [none, soft, hard]

placementGroup

string

The placement group of the server

preferredProcessorCompatibilityMode

string

Preferred processor compatibility mode

procType

string

Processor type (dedicated, shared, capped)

processors

number

Number of processors allocated

progress

number

The progress of an operation

pvmInstanceID

string

PCloud PVM Instance ID

sapProfile

object

If this is an SAP pvm-instance the profile reference will link to the SAP profile

serverName

string

Name of the server

sharedProcessorPool

string

The shared processor pool of the server

sharedProcessorPoolID

string

The shared processor pool id

softwareLicenses

object

The pvm instance Software Licenses

srcs

array

The pvm instance SRC lists

status

string

The status of the instance

storageConnection

string

The storage connection type

storagePool

string

Storage Pool where server is deployed

storagePoolAffinity

boolean

Indicates if all volumes attached to the server must reside in the same storage pool; Defaults to true when initially deploying a PVMInstance

storageType

string

Storage type where server is deployed

sysType

string

System type used to host the instance; use GET /v1/datacenters to retrieve supported system types for a location.

taskState

string

Represents the task state of a virtual machine (VM).

updatedDate

string

Date/Time of PVM last update

userTags

object

List of user tags

virtualCores

object

The pvm instance virtual CPU information

virtualSerialNumber

object

Information about Virtual Serial Number assigned to the PVM Instance

volumeIDs

array

List of volume IDs

vpmemVolumes

array

List of vPMEM volumes attached to this PVM Instance

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Update a PCloud PVM Instance

PUT /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance.update

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.update

Request

Request Body

PVMInstanceUpdate

Parameters to update a PCloud PVM Instance

allowRemoteRestart

boolean

if set to false, automated remote restart is disabled for the VM

defaultTrustedProfile

object

default IAM trusted profile to use for this virtual server instance

boolean

If set to true, the system will create a link to the specified trusted profile during server update. Regardless of whether a link is created by the system or manually using the IAM Identity service, it will be automatically deleted when the server is deleted.

target

object

trusted profile associated with the VM. Specify one of crn, id or name

licenseRepositoryCapacity

integer

The VTL license repository capacity TiB value

memory

number

Amount of memory allocated (in GiB)

metadataService

object

The metadata service configuration after update.

enabled

Required *

boolean

Indicates whether the metadata service endpoint will be available to the virtual server instance.

forceDisable

boolean

When true, allow the metadata service to be disabled while the VSI is active.

forceEnable

boolean

When true, allow the metadata service to be enabled while the VSI is active. The user is responsible for manually configuring networking on the VSI after the update. Only supported on Linux VSIs.

migratable

boolean

(deprecated - replaced by pinPolicy) Indicates if the server is allowed to migrate between hosts

pinPolicy

string

Specify PVM pin policy

preferredProcessorCompatibilityMode

string

Preferred processor compatibility mode

procType

string

Processor type (dedicated, shared, capped). When changing processor type without specifying processors, the system automatically converts the current core allocation. For dedicated to shared or capped conversion, the system reduces cores by 0.75 (for example, 1 dedicated core becomes 0.25 shared cores, 3 dedicated cores becomes 2.25 shared cores). For shared or capped to dedicated conversion, the system uses the VM's virtual cores as the new dedicated core count. To override this automatic conversion, explicitly provide the processors value.

processors

number

Number of processors allocated. When omitted during a procType change, the system automatically converts the current core count (see procType for conversion details). When explicitly provided, this value overrides automatic conversion.

sapProfileID

string

If an SAP pvm-instance, the SAP profile ID to switch to (only while shutdown)

serverName

string

Name of the server to create

softwareLicenses

object

The pvm instance Software Licenses

ibmiCSS

boolean

IBMi Cloud Storage Solution

ibmiDBQ

boolean

IBMi Cloud Storage Solution

ibmiPHA

boolean

IBMi Power High Availability IASP Management Software License

ibmiPHAFSM

boolean

IBMi Power High Availability Full System Manager (FSM) Software License

ibmiPHAFSMCount

integer

Number of IBMi Power High Availability Full System Manager (FSM) Managed Servers

ibmiRDS

boolean

IBMi Rational Dev Studio

ibmiRDSUsers

integer

IBMi Rational Dev Studio Number of User Licenses

storagePoolAffinity

boolean

Indicates if all volumes attached to the server must reside in the same storage pool; If set to false then volumes from any storage type and pool can be attached to the PVMInstance; Impacts PVMInstance snapshot, capture, and clone, for capture and clone - only data volumes that are of the same storage type and in the same storage pool of the PVMInstance's boot volume can be included; for snapshot - all data volumes to be included in the snapshot must reside in the same storage type and pool. Once set to false, cannot be set back to true unless all volumes attached reside in the same storage type and pool.

virtualCores

object

The pvm instance virtual CPU information

assigned

Required *

integer

The active virtual Cores

max

integer

The maximum DLPAR range for virtual Cores (Display only support)

min

integer

The minimum DLPAR range for virtual Cores (Display only support)

Response

202 - Accepted (this is a long running operation)

allowRemoteRestart

boolean

if set to false, automated remote restart is disabled for the VM

defaultTrustedProfile

object

default IAM trusted profile to use for this virtual server instance

licenseRepositoryCapacity

integer

The VTL license repository capacity TiB value

memory

number

Amount of memory allocated (in GiB)

metadataService

object

The metadata service configuration after update.

pinPolicy

string

Specify PVM pin policy

preferredProcessorCompatibilityMode

string

Preferred processor compatibility mode

procType

string

Processor type (dedicated, shared, capped)

processors

number

Number of processors allocated

serverName

string

Name of the server

statusUrl

string

URL to check for status of the operation (for now, just the URL for the GET on the server, which has status information)

storagePoolAffinity

boolean

Indicates if all volumes attached to the server must reside in the same storage pool; If set to false then volumes from any storage type and pool can be attached to the PVMInstance; Impacts PVMInstance snapshot, capture, and clone, for capture and clone - only data volumes that are of the same storage type and in the same storage pool of the PVMInstance's boot volume can be included; for snapshot - all data volumes to be included in the snapshot must reside in the same storage type and pool. Once set to false, cannot be set back to true unless all volumes attached reside in the same storage type and pool.

virtualCores

object

The pvm instance virtual CPU information

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Perform an action on a PVMInstance

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/action

Corresponding actions are 'start', 'stop', 'reboot', 'immediate-shutdown', 'reset'

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance.action

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.start
  • power-iaas.pvm-instance.stop
  • power-iaas.pvm-instance.immediate-shutdown
  • power-iaas.pvm-instance.renew
  • power-iaas.pvm-instance.unknown

Request

Request Body

PVMInstanceAction

Parameters for the desired action

action

Required *

string

Name of the action to take; can be 'dhcp-ip-sync' (on-prem only), 'dumprestart', 'hard-reboot', 'immediate-shutdown', 'reset-state', 'soft-reboot', 'start', 'stop'

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

500 - Internal Server Error

description

string

error

string

Capture a PVMInstance and create a deployable image

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/capture

This API is deprecated for /pcloud/v2/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/capture.

>Note: Support for this API is available till Oct 2022.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance-capture.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.capture

Request

Request Body

PVMInstanceCapture

Parameters for the capture PVMInstance

captureDestination

Required *

string

Destination for the deployable image

captureName

Required *

string

Name of the deployable image created for the captured PVMInstance

captureVolumeIDs

array

List of Data volume IDs to include in the captured PVMInstance

cloudStorageAccessKey

string

Cloud Storage Access key

cloudStorageImagePath

string

Cloud Storage Image Path (bucket-name [/folder/../..])

cloudStorageRegion

string

Cloud Storage Region

cloudStorageSecretKey

string

Cloud Storage Secret key

userTags

object

List of user tags

Response

200 - OK

202 - Accepted, upload to cloud storage in progress

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

List all console languages

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/console

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance-console.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.monitor

Request

Response

200 - OK

consoleLanguages

array

console languages

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Generate the noVNC Console URL

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/console

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance-console.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.monitor

Request

Response

201 - Created

consoleURL

string

The URL to the noVNC console for the PVM Instance

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Update PVMInstance console language code

PUT /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/console

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance-console.update

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.monitor

Request

Request Body

ConsoleLanguage

Parameters to update a PVMInstance console required codepage

code

Required *

string

language code

language

string

language description

Response

200 - OK

code

string

language code

language

string

language description

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get all networks for this PVM Instance

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/networks

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance-network.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance-network.list

Request

Response

200 - OK

networks

array

PVM Instance Networks

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Perform network addition

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/networks

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance-network.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance-network.create

Request

Request Body

PVMInstanceAddNetwork

Add network to PVM Instance parameters

ipAddress

string

The requested ip address of this network interface. Only valid when networkID is specified.

networkID

string

ID of the network. Required if externalNetworkInterfaceCRN is not specified. Cannot be combined with externalNetworkInterfaceCRN.

networkSecurityGroupIDs

array

Network security groups that the network interface is a member of. There is a limit of 1 network security group in the array. If not specified, default network security group is used. Only valid when networkID is specified.

Response

201 - Created

externalIP

string

The external ip address (for pub-vlan networks)

href

string

Link to PVM Instance Network

ip

string

(deprecated - replaced by ipAddress)

ipAddress

string

The ip address of this network interface

macAddress

string

The mac address of the network interface

networkID

string

ID of the network

networkInterfaceID

string

ID of the network interface

networkName

string

The name of the network the address is on

networkSecurityGroupIDs

array

IDs of the network necurity groups that the network interface is a member of

networkSecurityGroupsHref

array

Links to the network security groups that the network interface is a member of

type

string

The address type (fixed, dynamic, or externalFixed)

version

number

The version of the information provided

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Remove all Address of Network from a PVM Instance

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/networks/{network_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance-network.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance-network.delete

Request

Request Body

PVMInstanceRemoveNetwork

Remove a network from PVM Instance parameters

macAddress

string

The mac address of the network interface to be removed

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

410 - Gone

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get a PVM Instance's network information

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/networks/{network_id}

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance-network.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance-network.read

Request

Response

200 - OK

networks

array

PVM Instance Networks

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Perform an operation on a PVMInstance

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/operations

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance.operation

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.operation

Request

Request Body

PVMInstanceOperation

Parameters for the desired operations

operation

Required *

Operations

bootMode

string

Name of the server boot mode a(Boot from disk using copy A), b(Boot from disk using copy B), c(Reserved for IBM lab use only), d(Boot from media/drives)

operatingMode

string

Name of the server operating mode

task

string

Name of the job task to execute

operationType

Required *

string

Name of the operation to execute; can be job or boot

Response

200 - OK

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get all snapshots for this PVM Instance

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/snapshots

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance-snapshot.list

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.list

Request

Response

200 - OK

snapshots

array

List of PVM instance snapshots

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Create a PVM Instance snapshot

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/snapshots

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance-snapshot.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.snapshot

Request

Request Body

SnapshotCreate

PVM Instance snapshot create parameters

description

string

Description of the PVM instance snapshot

name

Required *

string

Name of the PVM instance snapshot to create

userTags

object

List of user tags

volumeIDs

array

List of volumes to include in the PVM instance snapshot

Response

202 - Accepted

crn

object

The CRN for this resource

snapshotID

string

ID of the PVM instance snapshot

userTags

object

List of user tags

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

500 - Internal Server Error

description

string

error

string

504 - Gateway Timeout

description

string

error

string

Restore a PVM Instance snapshot

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/snapshots/{snapshot_id}/restore

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance-snapshot.restore

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance.read

Request

Request Body

SnapshotRestore

PVM Instance snapshot restore parameters

force

boolean

By default the VM must be shutoff during a snapshot restore, force set to true will relax the VM shutoff pre-condition.

Response

202 - Accepted

action

string

Action performed on the instance snapshot

creationDate

string

Creation Date

description

string

Description of the PVM instance snapshot with a maximum of 255 characters allowed.

lastUpdateDate

string

Last Update Date

name

string

Name of the PVM instance snapshot

percentComplete

integer

Snapshot completion percentage

pvmInstanceID

string

PCloud PVM Instance ID

snapshotID

string

ID of the PVM instance snapshot

status

string

Status of the PVM instance snapshot

statusDetail

string

Detailed information for the last PVM instance snapshot action

volumeSnapshots

object

A map of volume snapshots included in the PVM instance snapshot

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

500 - Internal Server Error

description

string

error

string

Unassign Virtual Serial Number from a PVM Instance

DELETE /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/virtual-serial-number

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance-virtual-serial-number.delete

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance-virtual-serial-number.delete

Request

Request Body

DeleteServerVirtualSerialNumber

Parameters to unassign a Virtual Serial Number attached to a PVM Instance

retainVSN

boolean

Indicates if the Virtual Serial Number attached to a PVM Instance is retained or not

Response

202 - Accepted

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

410 - Gone

description

string

error

string

500 - Internal Server Error

description

string

error

string

Get a PVM Instance's Virtual Serial Number Information

GET /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/virtual-serial-number

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.read
  • power-iaas.pvm-instance-virtual-serial-number.read

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance-virtual-serial-number.read

Request

Response

200 - OK

description

string

Description of the Virtual Serial Number

pvmInstanceID

string

ID of the PVM Instance Virtual Serial Number is attached to.

serial

string

Virtual Serial Number assigned to the PVM Instance

softwareTier

object

IBMi licensing software tier for the VSI.

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

500 - Internal Server Error

description

string

error

string

Assign Virtual Serial Number to a PVM Instance

POST /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/virtual-serial-number

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance-virtual-serial-number.create

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance-virtual-serial-number.create

Request

Request Body

AddServerVirtualSerialNumber

Parameters to assign Virtual Serial Number to a PVM Instance

description

string

Description of the Virtual Serial Number

serial

Required *

string

Provide an existing reserved Virtual Serial Number or specify 'auto-assign' for auto generated Virtual Serial Number.

Response

202 - Accepted

description

string

Description of the Virtual Serial Number

pvmInstanceID

string

ID of the PVM Instance Virtual Serial Number is attached to.

serial

string

Virtual Serial Number assigned to the PVM Instance

softwareTier

object

IBMi licensing software tier for the VSI.

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

409 - Conflict

description

string

error

string

500 - Internal Server Error

description

string

error

string

504 - Gateway Timeout

description

string

error

string

Update a Virtual Serial Number

PUT /pcloud/v1/cloud-instances/{cloud_instance_id}/pvm-instances/{pvm_instance_id}/virtual-serial-number

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

  • power-iaas.cloud-instance.modify
  • power-iaas.pvm-instance-virtual-serial-number.update

Auditing

Calling this method generates the following auditing event.

  • power-iaas.pvm-instance-virtual-serial-number.update

Request

Request Body

UpdateServerVirtualSerialNumber

Parameters to update a Virtual Serial Number description

description

string

Description of the Virtual Serial Number

softwareTier

object

IBMi licensing software tier for the VSI.

Response

200 - OK

description

string

Description of the Virtual Serial Number

pvmInstanceID

string

ID of the PVM Instance Virtual Serial Number is attached to.

serial

string

Virtual Serial Number assigned to the PVM Instance

softwareTier

object

IBMi licensing software tier for the VSI.

202 - Accepted

description

string

Description of the Virtual Serial Number

pvmInstanceID

string

ID of the PVM Instance Virtual Serial Number is attached to.

serial

string

Virtual Serial Number assigned to the PVM Instance

softwareTier

object

IBMi licensing software tier for the VSI.

400 - Bad Request

description

string

error

string

401 - Unauthorized

description

string

error

string

403 - Forbidden

description

string

error

string

404 - Not Found

description

string

error

string

422 - Unprocessable Entity

description

string

error

string

500 - Internal Server Error

description

string

error

string

[...]
